#!/bin/bash

generate_index() {
  for path in "$@"; do
    local base=$(basename "${path}")
    local exac=${base%.ts}
    local dir=$(dirname "${path}")

    local segments
    local p

    IFS="/" read -a segments <<< $path

    for segment in ${segments[@]}; do

      if [ "$segment" == "." ] || [ "$segment" == "dist" ]; then
        p+="$segment"
        p+="/"
        continue
      fi

      local exp

      if [ "$segment" == "$base" ]; then
        exp="export * from './$exac'"
        if ! grep -Fxq "$exp" "$dir"/index.ts; then
          echo "$exp" | tee -a "$dir"/index.ts
        fi
        p=""
      elif [ "$segment" == "$exac" ]; then
        exp="export * as $segment from './$segment'"
        if ! grep -Fxq "$exp" "$p"/index.ts; then
           echo "$exp" | tee -a "$p"/index.ts
        fi
        p+="$segment"
        p+="/"
      else
        exp="export * as $segment from './$segment'"
        if ! grep -Fxq "$exp" "$p"index.ts; then
          echo "$exp" | tee -a "$p"index.ts
        fi
        p+="$segment"
        p+="/"
      fi

    done
  done
}

cd ./config

echo "Generate index.ts files"
ts_files=$(find ./dist -name '*.ts' -type f)
ts_files_array=($ts_files)
generate_index "${ts_files_array[@]}"

echo "Generate *.js files"
npx tsc --declaration --declarationMap --sourceMap --rootDir ./dist

echo "Delete temporary files"
find ./dist -name '*.ts' ! -name '*.d.ts' -type f -delete

echo "Process finished"